<?php
// require config.php!
class UserMgmt {
	private $_user_data_file;
	
	public function __construct() {
		global $ne2_config_info;
		$this->_user_data_file = $ne2_config_info['app_path'] . 'data/' . $ne2_config_info['user_data_file_name'];
	}
	
	public function GetUsers() {
		if(!file_exists($this->_user_data_file)) {
			touch($this->_user_data_file); // create file if not exists
			return NULL;
		}
		$jss = file_get_contents($this->_user_data_file);
		if($jss == '') {
			return NULL;
		} else {
			$test_jss = json_decode(stripslashes($jss), TRUE);
			if(isset($test_jss[0]['permission'])) {
				return $jss;
			} else {
				// add permission column (should run only once!)
				$copy_jss = array();
				foreach($test_jss as $tj) {
					array_push($copy_jss, array(
						'user_name' => $tj['user_name'],
						'password_hash' => $tj['password_hash'],
						'permission' => '/index.shtml'
					));
				}
				$new_jss = json_encode($copy_jss);
				file_put_contents($this->_user_data_file, $new_jss); // rewrite!
				return $new_jss;
			}
		}
	}
	
	public function AddUser($user_name, $passwd, $init_permission) {
		$jss = file_get_contents($this->_user_data_file);
		$users = json_decode(stripslashes($jss), TRUE);
		if(!is_null($users)) {
			foreach($users as $udata) {
				if(strcmp($udata['user_name'], $user_name) == 0) {
					return FALSE;
				}
			}
		}
		if(is_null($users)) {
			$users = array();
		}
		$pwd_hash = md5($passwd);
		array_push($users, array(
			'user_name' => $user_name,
			'password_hash' => $pwd_hash,
			'permission' => $init_permission
		));
		$jss1 = json_encode($users);
		file_put_contents($this->_user_data_file, $jss1);
		return TRUE;
	}
	
	public function Login($user_name, $passwd) {
		$jss = file_get_contents($this->_user_data_file);
		if($jss == '') {
			return FALSE;
		} else {
			$users = json_decode(stripslashes($jss), TRUE);
			foreach($users as $udata) {
				if(strcmp($udata['user_name'], $user_name) == 0) {
					if(strcmp($udata['password_hash'], md5($passwd)) == 0) {
						return TRUE;
					} else {
						return FALSE;
					}
				}
			}
			return FALSE;
		}
	}
	
	public function UpdateUser($user_name, $new_pwd, $new_permission) {
		$jss = file_get_contents($this->_user_data_file);
		if($jss == '') {
			return FALSE;
		} else {
			$users = json_decode(stripslashes($jss), TRUE);
			for($i = 0; $i < count($users); $i++) {
				if(strcmp($users[$i]['user_name'], $user_name) == 0) {
					if($new_pwd != '') {
						$users[$i]['password_hash'] = md5($new_pwd);
					}
					$users[$i]['permission'] = $new_permission;
					break;
				}
			}
			$jss1 = json_encode($users);
			file_put_contents($this->_user_data_file, $jss1);
			return TRUE;
		}
	}
	
	public function RemoveUser($user_name) {
		$jss = file_get_contents($this->_user_data_file);
		if($jss == '') {
			return FALSE;
		} else {
			$users = json_decode(stripslashes($jss), TRUE);
			for($i = 0; $i < count($users); $i++) {
				if(strcmp($users[$i]['user_name'], $user_name) == 0) {
					array_splice($users, $i, 1);
					break;
				}
			}
			$jss1 = json_encode($users);
			file_put_contents($this->_user_data_file, $jss1);
			return TRUE;
		}
	}
	
	public function UserHasPermission($user_name, $file_path) {
		$user_data_string = file_get_contents($this->_user_data_file);
		if($user_data_string == '') {
			return FALSE;
		}
		$user_data = json_decode(stripslashes($user_data_string), TRUE);
		foreach($user_data as $ud) {
			if(strcmp($ud['user_name'], $user_name) == 0) {
				if($ud['permission'] == '/index.shtml') { // can do everything
					return TRUE;
				} else {
					if(strpos($ud['permission'], 'index.shtml') !== FALSE) { // has permission of a dir
						$test_perm = str_replace('index.shtml', '', $ud['permission']);
						if(strpos($file_path, $test_perm) !== FALSE) {
							return TRUE;
						} else {
							return FALSE;
						}
					} else { // has permission only of a certain file
						if($ud['permission'] == $file_path) {
							return TRUE;
						} else {
							return FALSE;
						}
					}
				}
			}
		}
		return FALSE; // no such user!
	}
	
	public function ChangePermissionPath($user_name, $old_path, $new_path) {
		// ...
	}
	
	public function GetPermission($user_name) {
		$user_data_str = file_get_contents($this->_user_data_file);
		$user_data = json_decode(stripslashes($user_data_str), TRUE);
		foreach($user_data as $ud) {
			if($ud['user_name'] == $user_name) {
				return $ud['permission'];
			}
		}
		return 'NO_SUCH_USER';
	}
}
?>
